;--------------------------------------------------------------
; BOOT ROM for AI-1000(LISP)/PB-2000C(C)
; System   :  CASIO AI-1000/PB-2000C + Flash ROM CARD
; Produce  :  Copyright (c) BLUE & |El 2022
; Homepage :  http://hd61700.yukimizake.net/
;--------------------------------------------------------------
;##### MODEL NUMBER #####
AI1000:	EQU	1		;AI-1000
PB2000C:EQU	2		;PB-2000C

;##### MODEL SELECT #####
MODEL:	EQU	AI1000		;pVXeLq

;------------------------------------------------------------
;ROMp萔iʁj
;------------------------------------------------------------
ROMSYG:	EQU	&H4D43		;ROMʎqiŒlj
CONTR:	EQU	&H0D6A		;RgXgl

;------------------------------------------------------------
;INTERUPTiʁj
;------------------------------------------------------------
INTON:	EQU	&H01AA		;ON 荞
INT1M:	EQU	&H01BC		;1^C}[荞
INTRCV:	EQU	&H00E3		;M荞
OFFCHK:	EQU	&H04EF		;dOFF`FbN

CRTKY:	EQU	&H0460		;L[(RgXgL[܂)
SETBK:	EQU	&H0276		;SET BANK($6) & RETURN

;------------------------------------------------------------
; AI-1000/LISPp`
;------------------------------------------------------------
#if MODEL=AI1000
;LISP Language
SYSCLR:	EQU	&H311C		;VXe[N(LISP)
SETLCD:	EQU	&H3242		;LCDo̓Zbg(OUTDV=0)
OUTCR:	EQU	&H3AF6		;CR-LFo
CLS:	EQU	&H3AED		;CLS(PRINT CHR$(12))
OUTSTR:	EQU	&H28FC		;o($15,$16=A$17=)
SET4LN:	EQU	&H2899		;LCDʏ(4sXN[)ݒ

CROFF:	EQU	&H22BB		;J[\\OFF
DOTDS:	EQU	&H22D1		;LEDTP̓eLCDCɓ]
CLEDB:	EQU	&H2397		;LCDʃNA
DOTMK:	EQU	&H28A4		;$10,$11Ŏw肵EDTOP̕p^[LEDTPɓWJ
BRSTR:	EQU	&H3233		;ACJMP=$2,$3
BEEPS:	EQU	&H3902		;w蒷BEEP($2,$3=̒)
EXBN1:	EQU	&H19AA		;s(EXPRW+BIN01)Bs$18<>1Ȃ$15,$16=0
#endif
;------------------------------------------------------------
; PB-2000C/Cp`
;------------------------------------------------------------
#if MODEL=PB2000C
;C Language
SYSCLR:	EQU	&H3169		;VXe[N(LISP)
SETLCD:	EQU	&H328F		;LCDo̓Zbg(OUTDV=0)
OUTCR:	EQU	&H3B47		;CR-LFo
CLS:	EQU	&H3B3A		;CLS(PRINT CHR$(12))
OUTSTR:	EQU	&H293B		;o($15,$16=A$17=)
SET4LN:	EQU	&H28D8		;LCDʏ(4sXN[)ݒ

CROFF:	EQU	&H22FA		;J[\\OFF
DOTDS:	EQU	&H2310		;LEDTP̓eLCDCɓ]
CLEDB:	EQU	&H23D6		;LCDʃNA
DOTMK:	EQU	&H28E3		;$10,$11Ŏw肵EDTOP̕p^[LEDTPɓWJ
BRSTR:	EQU	&H3280		;ACJMP=$2,$3
BEEPS:	EQU	&H3953		;w蒷BEEP($2,$3=̒)
EXBN1:	EQU	&H19BB		;s(EXPRW+BIN01)Bs$18<>1Ȃ$15,$16=0

#endif

;------------------------------------------------------------
;VXeGA(AI-1000/PB-2000C)
;------------------------------------------------------------
EDTOP:	EQU	&H0100		;EDTOPobt@
LEDTP:	EQU	&H0201		;LCD\hbgobt@
ELVAD:	EQU	&H08D5		;RgXgݒl
APOCN:	EQU	&H08D9		;dOFFp
WORK1:	EQU	&H0CE6		;WORK1

SSPTP:	EQU	&H0FEF		;VXeX^bNl
USPTP:	EQU	&H0CE2		;[U[X^bNl
SSPBT:	EQU	&H0EEE		;
RCS:	EQU	SSPBT+16	;oNP풓

;--------------------------------------------------------------
org	0				;ROM HEADDER
;--------------------------------------------------------------
	DW	ROMSYG			;ROMʎqiŒlj
	DB	&HFF,&HFF,&HFF,&HFF	;Dummy
	DB	&H01,&H04,&H10,&H10	;ROMʎqQiŒlj
	DB	&HFF,&HFF,&HFF,&HFF	;
	DB	&HFF,&HFF,&HFF,&HFF	;
	DB	&HFF,&HFF,&HFF,&HFF	;
	DB	&HFF,&HFF,&HFF,&HFF	;
	DB	&HFF			;
;
	DB	&H03		;ROM2 Select(C10hݒl)
	DB	&HC0		;ROM3 Select(C11hݒl)
;
	DB	&HFF,&HFF,&HFF	;
;
;--------------------------------------------------------------
org	&h0C20			;oN1(BK1SYS)풓
;--------------------------------------------------------------
; call to a routine in the bank 0 pointed to by $28,$29
; [Reference]
;  Executing machine code on the Casio PB-2000C
;  http://www.pisi.com.pl/piotr433/pb2000xe.htm (by Piotr Piatek)
;--------------------------------------------------------------
RCS_TOP:
	GST	UA,$6		;$6ޔ
	PHS	$6		;

	LDW	$6,SETBK-1	;oN0߂ʒuݒ
	PHSW	$7		;

	PST	UA,&H54		;oN0Ăяo
	JP	$28		;
_SYSCAL:
	PST	UA,&H45		;SELECT LISP ROM
	LDW	$6,&Hc10	;
	ST	$31,($6)	; 0 -> &h0c10

	CAL	RCS		;oN0Ăяo

	PST	UA,&H45		;SELECT ROM CARD
	LDW	$6,&Hc10	;
	LD	$28,3		;
	ST	$28,($6)	; 3 -> &h0c10

	PST	UA,&H54		;Return bank0
	RTN			;
RCS_END:

;--------------------------------------------------------------
; LISPVXeďo
;--------------------------------------------------------------
	org	&H0C50
SYSCAL:
	PST	UA,&H55		;oN1Ăяo
	JP	RCS+(_SYSCAL-RCS_TOP)

BIOS:
	CAL	USER0		;oN0ďo
	PST	UA,&H55		;oN1ɖ߂
	RTN
USER0:
	JP	$28


;--------------------------------------------------------------
; INKEY$($0=L[́A$17:L[L)
;--------------------------------------------------------------
	org	&H0C60
INKEY:
	CAL	OFFCHK		;dOFF`FbN
	LD	$17,$31		;L[͂Ȃ
	LD	$0,&H4B		;KIl
IKEYLP:
	PST	IA,$0		;L[XLR[hݒ

	GRE	KY,$1		;Dummy
	GRE	KY,$1		;L[ԓǂݏo

	DID	$2		;bit8`bit11}XN
	ANCW	$1,$1		;L[H
	JR	Z,IKEY40	;No.-->jump

	SBC	$0,&H41		;[BRK]H
	JP	Z,&H0001	;Yes-->dON蒼

IKEY10:
	;-------------------------
	;$0   ---L[XLԍ
	;$1,$2---L[XL
	;-------------------------
	LD	$3,$31		;rbgʒuJE^
IKEY20:
	BIDW	$2		;L[rbgC
	JR	C,IKEY30	;Ȃ番
	
	AD	$3,$30,IKEY20	;rbgʒuJE^+1

IKEY30:
	;-------------------------
	;e[u擪ʒu$4쐬
	;-------------------------
	LD	$5,$0		;
	SB	$5,$30		;$5=$0-1
	BIU	$5		;
	BIU	$5		;$5=($0-1)*4
	LD	$4,$5		;
	BIU	$4		;
	BIU	$4		;$4=($0-1)*16
	SB	$4,$5		;$4=($0-1)*12(16{-4{=12{)
	;-------------------------
	;INKEY$R[hɕύX
	;-------------------------
	PST	UA,&H44		;IX/IY=BANK0AIZ=BANK1APC=BANK0
	PRE	IX,_KEYSCAN	;L[R[hϊe[u擪
	LDD	$0,(IX+$4)	;IX=IX+$4
	LDD	$0,(IX+$3)	;$0=L[R[h
	PST	UA,&H54		;IX/IY=BANK1AIZ=BANK1APC=BANK0
	JR	IKEY50

IKEY40:
	SB	$0,$30		;L[XLR[hXV-1
	JR	LNZ,IKEYLP	;IH

	LD	$0,$31		;L[R[h
IKEY50:
	AN	$0,$0		;L[͂H
	JR	Z,IKEYRET	;No.-->jump

	LD	$17,$30		;L[͂Ԃ
IKEYRET:
	LDW	$15,WORK1	;L[R[hWORK1ɓ
	ST	$0,($15)	;

	RTN

;-------------------------
;INKEY$R[hύXTABLE
;-------------------------
_KEYSCAN:
_KEY01:	;---------IA=1 ----------
	DB	0		;
	DB	0		;
	DB	0		;
	DB	0		;
	DB	0		;
	DB	0		;
	DB	0		;
	DB	1		;BRK
	DB	0		;
	DB	0		;
	DB	0		;
	DB	0		;
_KEY02:	;---------IA=2 ----------
	DB	"W"		;W
	DB	"Q"		;Q
	DB	"A"		;A
	DB	0		;
	DB	"Z"		;Z
	DB	0		;CAPS
	DB	0		;
	DB	0		;
	DB	0		;
	DB	0		;
	DB	"'"		;'
	DB	7		;TAB
_KEY03:	;---------IA=3 ----------
	DB	"R"		;R
	DB	"E"		;E
	DB	"D"		;D
	DB	"S"		;S
	DB	"C"		;C
	DB	"X"		;X
	DB	0		;
	DB	0		;
	DB	&HFC		;MENU1
	DB	0		;
	DB	&H29		;)
	DB	&H28		;(
_KEY04:	;---------IA=4 ----------
	DB	"Y"		;Y
	DB	"T"		;T
	DB	"G"		;G
	DB	"F"		;F
	DB	"B"		;B
	DB	"V"		;V
	DB	0		;
	DB	0		;
	DB	&HFD		;MENU2
	DB	0		;
	DB	&H5D		;]
	DB	&H5B		;[
_KEY05:	;---------IA=5 ----------
	DB	"I"		;I
	DB	"U"		;U
	DB	"J"		;J
	DB	"H"		;H
	DB	"M"		;M
	DB	"N"		;N
	DB	0		;
	DB	0		;
	DB	&HFE		;MENU3
	DB	0		;
	DB	&H90		;MEMO
	DB	&H7C		;|
_KEY06:	;---------IA=6 ----------
	DB	"P"		;P
	DB	"O"		;O
	DB	"L"		;L
	DB	"K"		;K
	DB	&H20		;SPC
	DB	","		;,
	DB	0		;
	DB	0		;
	DB	&HFF		;MENU4
	DB	0		;
	DB	&H93		;OUT
	DB	&H94		;IN
_KEY07:	;---------IA=7 ----------
	DB	0		;
	DB	"="		;=
	DB	":"		;:
	DB	";"		;;
	DB	0		;
	DB	0		;ANS
	DB	0		;[S]
	DB	0		;
	DB	&H95		;ETC
	DB	0		;
	DB	0		;
	DB	&H9B		;CALC
_KEY08:	;---------IA=8 ----------
	DB	"5"		;5
	DB	"4"		;4
	DB	"2"		;2
	DB	"1"		;1
	DB	0		;
	DB	"0"		;0
	DB	0		;
	DB	"7"		;7
	DB	0		;
	DB	0		;NEW ALL
	DB	0		;
	DB	0		;
_KEY09:	;---------IA=9 ----------
	DB	"-"		;-
	DB	"6"		;6
	DB	"+"		;+
	DB	"3"		;3
	DB	&HD		;EXE
	DB	"."		;.
	DB	0		;
	DB	"9"		;9
	DB	0		;
	DB	0		;
	DB	0		;
	DB	0		;
_KEY10:	;---------IA=10----------
	DB	&H9D		;CAL
	DB	&H1C		;
	DB	"/"		;/
	DB	&H08		;BS
	DB	0		;
	DB	0		;
	DB	0		;
	DB	"*"		;*
	DB	0		;
	DB	0		;
	DB	&H9C		;MENU
	DB	&H11		;DEL
_KEY11:	;---------IA=11----------
	DB	&H1F		;
	DB	&H1D		;
	DB	&H0C		;CLS
	DB	0		;
	DB	0		;
	DB	0		;
	DB	0		;
	DB	"8"		;8
	DB	0		;
	DB	0		;
	DB	&H1E		;
	DB	&H12		;INS

;--------------------------------------------------------------
org	&h0D40			;ROM CALL ROUTINE
;--------------------------------------------------------------
@CROFF:
	LDW	$28,CROFF	;J[\\OFF
	JR	SYSC		;LISPďo

@DOTDS:
	LDW	$28,DOTDS	;DOTDS
	JR	SYSC		;LISPďo

@CLEDB:
	LDW	$28,CLEDB	;CLEDB ʏ
	JR	SYSC		;LISPďo

@DOTMK:
	LDW	$28,DOTMK	;DOTMK $10,$11Ŏw肵EDTOP̕p^[LEDTPɓWJ
	JR	SYSC		;LISPďo

@BRSTR:
	LDW	$28,BRSTR	;BRSTR ACJMP=$2,$3
	JR	SYSC		;LISPďo

@SYSCLR:
	LDW	$28,SYSCLR	;VXe[N
	JR	SYSC		;LISPďo

@CRTKY:
	LDW	$28,CRTKY	;L[(ROM)
	JR	SYSC		;LISPďo

@SETLCD:
	LDW	$28,SETLCD	;LCDo̓Zbg(OUTDV=0)
	JR	SYSC		;LISPďo

@BEEPS:
	LDW	$28,BEEPS	;w蒷BEEP($2,$3=̒)
	JR	SYSC		;LISPďo
@EXBN1:
	LDW	$28,EXBN1	;s(EXPRW+BIN01)Bs$18<>1Ȃ$15,$16=0
SYSC:	JP	SYSCAL		;LISPďo


;--------------------------------------------------------------
org	&h0D80			;BOOT VECTOR
;--------------------------------------------------------------
	jp	MAIN		; dON^Zbg
	jp	TRAP		; TRP
	jp	INTON		; ON interrupt
	jp	INT1M		; 1^C}[荞
	jp	TRAP		; INT2
	jp	TRAP		; KEY/pX荞
	jp	TRAP		; INT1
	jp	INTRCV		; M荞
DEFRT:	rtn
;--------------------------------------------------------------
	DB	&HFF,&HFF	; Dummy
;--------------------------------------------------------------
	jp	DEFRT		; check the user stack space
	jp	POFF		; power-off
	jp	DEFRT		; decode the pressed key
	jp	DEFRT
	jp	DEFRT		; BRK key handler procedure
	jp	DEFRT		; BS Error, subscript out of range
	jp	DEFRT		; SN Error, syntax
	jp	DEFRT		; MA Error, mathematical error
	jp	DEFRT		; OV Error, overflow
;--------------------------------------------------------------
ROMID:	db	&H11		; ROM-ID
	db	&H10		; ROM-Version
;--------------------------------------------------------------
;--------------------------------------------------------------
TRAP:	rtni			;gbv荞ݗp
;--------------------------------------------------------------
POFF:	off			;dOFF
;--------------------------------------------------------------
	off
	off
	off
	jr	POFF

;--------------------------------------------------------------
; C($16=1:ʏA0:RESET)
;--------------------------------------------------------------
MAIN:
	PRE	IX,RCS_TOP	;oN1풓SRAMɓ]
	PRE	IY,RCS_END-1	;
	PRE	IZ,RCS		;
	PST	UA,&H44		;IX/IY=BANK0AIZ=BANK1APC=BANK0
	BUP			;

	PST	UA,&H54		;IX/IY/IZ=BANK1APC=BANK0
	PRE	SS,SSPTP	;VXeX^bN
	PRE	US,USPTP	;[U[X^bN

	PRE	IX,ELVAD	;RgXgݒ
	LDW	$0,CONTR	;
	STW	$0,(IX+$31)	;

	PRE	IX,APOCN	;dOFF[h
	LD	$0,7		;
	ST	$0,(IX+$31)	;

	CAL	@SYSCLR		;RESET̃VXe[N

	CAL	@SETLCD		;o͐LCDɐݒ
	LDW	$28,SET4LN	;LCDʏ(4sXN[)ݒ
	CAL	SYSCAL		;

	PRE	IZ,EDTOP	;LCD擪
	PRE	IX,MSG01	;\bZ[W
	CAL	MSGPS		;

	PRE	IZ,EDTOP+32	;LCD 1s
	PRE	IX,MSG02	;\bZ[W
	CAL	MSGPS		;

	PRE	IZ,EDTOP+32*2	;LCD 2s
	PRE	IX,MSG03	;\bZ[W
	CAL	MSGPS		;

	PRE	IZ,EDTOP+32*3	;LCD 3s
	PRE	IX,MSG04	;\bZ[W
	CAL	MSGPS		;

	LDW	$10,&H7F00	;DOTMK
	CAL	@DOTMK		;

	CAL	@DOTDS		;LCDʕ\

loop:
	LDW	$2,$30		;ѐdONɐݒ
	CAL	@BRSTR		;ACJMPݒ

	CAL	@CROFF		;J[\\OFF
	LDW	$28,CRTKY	;L[(ROM)
	CAL	SYSCAL		;

	SBC	$0,"1"		;PROG01NH
	JR	Z,PROG1		;

	SBC	$0,"2"		;PROG02NH
	JR	Z,PROG2		;

	SBC	$0,"3"		;PROG03NH
	JR	Z,PROG3		;

	SBC	$0,"4"		;PROG04NH
	JR	Z,PROG4		;

	SBC	$0,"5"		;PROG05NH
	JP	Z,PROG5		;

	SBC	$0,"M"		;PROG MONITORNH
	JP	Z,PROGM		;

	JR	loop

;-------------------------
;EXECUTE PROG01
;-------------------------
PROG1:
	CAL	@CLEDB		;ʏ
	CAL	@DOTDS		;LCDʕ\

	PRE	IX,PRG01	;PROG1 I
	PRE	IY,PRG01E-1	;

	PRE	IZ,&h2000	;oNPɓ]
	PST	UA,&H44		;IX/IY=BANK0AIZ=BANK1APC=BANK0
	BUP			;

	PST	UA,&H55		;IX/IY=BANK1AIZ=BANK1APC=BANK1
	CAL	&H2000		;PROG01s
	JP	&H0001		;Yes-->dON蒼

;-------------------------
;EXECUTE PROG02
;-------------------------
PROG2:
	CAL	@CLEDB		;ʏ
	CAL	@DOTDS		;LCDʕ\

	PRE	IX,PRG02	;PROG2 I
	PRE	IY,PRG02E-1	;

	PRE	IZ,&h2000	;oNPɓ]
	PST	UA,&H44		;IX/IY=BANK0AIZ=BANK1APC=BANK0
	BUP			;

	PST	UA,&H55		;IX/IY=BANK1AIZ=BANK1APC=BANK1
	CAL	&H2000		;PROG02s
	JP	&H0001		;Yes-->dON蒼

;-------------------------
;EXECUTE PROG03
;-------------------------
PROG3:
	CAL	@CLEDB		;ʏ
	CAL	@DOTDS		;LCDʕ\

	PRE	IX,PRG03	;PROG2 I
	PRE	IY,PRG03E-1	;

	PRE	IZ,&h2000	;oNPɓ]
	PST	UA,&H44		;IX/IY=BANK0AIZ=BANK1APC=BANK0
	BUP			;

	PST	UA,&H55		;IX/IY=BANK1AIZ=BANK1APC=BANK1
	CAL	&H2000		;PROG03s
	JP	&H0001		;Yes-->dON蒼

;-------------------------
;EXECUTE PROG04
;-------------------------
PROG4:
	CAL	@CLEDB		;ʏ
	CAL	@DOTDS		;LCDʕ\

	PRE	IX,PRG04	;PROG2 I
	PRE	IY,PRG04E-1	;

	PRE	IZ,&h2000	;oNPɓ]
	PST	UA,&H44		;IX/IY=BANK0AIZ=BANK1APC=BANK0
	BUP			;

	PST	UA,&H55		;IX/IY=BANK1AIZ=BANK1APC=BANK1
	CAL	&H2000		;PROG04s
	JP	&H0001		;Yes-->dON蒼

;-------------------------
;EXECUTE PROG05
;-------------------------
PROG5:
	CAL	@CLEDB		;ʏ
	CAL	@DOTDS		;LCDʕ\

	PRE	IX,PRG05	;PROG2 I
	PRE	IY,PRG05E-1	;

	PRE	IZ,&h2000	;oNPɓ]
	PST	UA,&H44		;IX/IY=BANK0AIZ=BANK1APC=BANK0
	BUP			;

	PST	UA,&H55		;IX/IY=BANK1AIZ=BANK1APC=BANK1
	CAL	&H22F0		;PROG05s
	JP	&H0001		;Yes-->dON蒼

;-------------------------
;EXECUTE MONITOR(LEMON)
;-------------------------
PROGM:
	CAL	@CLEDB		;ʏ
	CAL	@DOTDS		;LCDʕ\

	PRE	IX,PRG0M	;PRG0M I
	PRE	IY,PRG0ME-1	;

	PRE	IZ,LEDTP+24	;oNPɓ]
	PST	UA,&H44		;IX/IY=BANK0AIZ=BANK1APC=BANK0
	BUP			;

	PST	UA,&H55		;IX/IY=BANK1AIZ=BANK1APC=BANK1
	CAL	LEDTP+24	;PROG02s
	JP	&H0001		;Yes-->dON蒼

;------------------------------------------------------------
; bZ[W\
; ́FIZ --- bZ[Wi[AhX
;       IX --- \JnAhX
;------------------------------------------------------------
MSGPS:
	GST	UA,$1		;oNۑ
	PST	UA,&H44		;IX=BANK0,IZ=BANK1w
	LDI	$0,(IX+$31)	;P肾
	PST	UA,$1		;oNA

	ANC	$0,$0		;\I?
	RTN	Z		;

	STI	$0,(IZ+$31)	;ʕ\
	JR	MSGPS		;

;------------------------------------------------------------
; \
;------------------------------------------------------------
MSG01:	DB      "SELECT PROGRAM?",0
MSG02:	DB      "1:ALIEN SHOOTER 4:BATTLE SHOOTER",0
MSG03:	DB      "2:UFO GAME      5:BLOCKS",0
MSG04:	DB      "3:BIG SHOOTER   M:MONITOR",0

PRG01:
#INCLUDE(.\prg\alis.s)
PRG01E:

PRG02:
#INCLUDE(.\prg\ufog.s)
PRG02E:

PRG03:
#INCLUDE(.\prg\bigs.s)
PRG03E:

PRG04:
#INCLUDE(.\prg\btls.s)
PRG04E:

PRG05:
#INCLUDE(.\prg\blocks.s)
PRG05E:

PRG0M:
#INCLUDE(.\prg\lemon.s)
PRG0ME:

;--------------------------------------------------------------
; ROMŏI
;--------------------------------------------------------------
	org	65535
	db	0
